'' IRwithCOG.spin
'' =================================================================================================
''
''   File....... IRwithCOG.spin
''   Purpose.... 
''   Author..... Jon "JonnyMac" McPhalen (aka Jon Williams)          Modidfied by Lockadoc (Bill S)
''   E-mail..... jon@jonmcphalen.com
''   Started.... 
''   Updated.... 15 JAN 2010
''
'' =================================================================================================


con

  _clkmode  = xtal1 + pll16x
  _xinfreq  = 5_000_000


con

  MS_001 = 80_000_000 / 1_000                                   ' ticks per ms @ 80MHz

  CH_UP   = %0010000                                             'pulls the last 7 bits of the IR code
  CH_DN   = %0010001                                             'pulls the last 7 bits of the IR code
  VOL_UP  = %0010010                                             'pulls the last 7 bits of the IR code
  VOL_DN  = %0010011                                             'pulls the last 7 bits of the IR code
  Prev_ch =  %0111011                                              'pulls the last 7 bits of the IR code

  IR     = 16                                                   '  IR on pin 16
                                                                ' the outputs are on pins 1 to 7
  
 
   
Var
 long IRStack[10]                                                 'Stack Space for the new cog
 byte IRwithCogId                                                     'Store new cog ID


obj
  
  sircs      : "jm_sircs_rx"                                  ' sircs decoding 
  lightshow3 : "LIGHTSHOW3"                                   ' Light display pattern
  lightshow4 : "LIGHTSHOW4"                                   ' Light display pattern 
  lightshow6 : "LIGHTSHOW6"                                   ' Light display pattern 
  lightshow7 : "LIGHTSHOW7"                                   ' Light display pattern 
  TempLights : "TempLights"

Pub Start                                                     'Starts the new cog method
  Stop                                                        'Prevents multiple starts of this method
  IRwithCOGId := cognew (IRwithCOG, @IRStack)+1               'Starts and gets a cog ID

  
Pub Stop                                                      'Stops the cog that was started  
   if IRwithCogId > -1
    cogstop (IRwithcogId-1)
 
pub IRwithCOG | code

 

  sircs.init(IR)                                              ' start SIRCS object

  repeat
    code := sircs.getir                                       ' wait for SIRCS
    code := code & $7F                                        ' limit to lower 7 bits 
    case code                                                 ' check against known keys
      CH_UP  : lightshow3 .lightshow3
      CH_DN  : lightshow4 .lightshow4
      VOL_UP : lightshow6 .lightshow6
      VOL_DN : lightshow7 .lightshow7
      prev_ch: Templights .TempLights


    